﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bucherei
{
    internal abstract class Medium : IFormatable
    {
        internal string Signatur {  get; private set; }
        protected string Autor { get; }
        protected string Titel { get; }
        internal Medium(string signatur, string autor, string titel)
        {
            Signatur = signatur;
            Autor = autor;
            Titel = titel;
        }

        public abstract string Format();
        internal void UpdateSignature()
        {
            this.Signatur = Autor+Titel;
        }
        public override string ToString()
        {
            return this.Format();
        }

        // Fakrikmethode
        internal static Medium Erzeugen(string signatur, string autor, string titel, char typ, int seitenzahl, double spieldauer)

        {
            if (typ == 'B') return new Buch(signatur, autor, titel, seitenzahl);
            else if (typ == 'C') return new CD(signatur, autor, titel, spieldauer);
            else
            {
                Console.WriteLine($"Unbekannter Typ: {typ}");
            }
            return null;
        }
    }
    internal class Buch : Medium
    {
        int Seitenzahl { get; }
        internal Buch(string signatur, string autor, string titel, int seitenzahl)
            : base(signatur, autor, titel)
        {
            Seitenzahl = seitenzahl;
        }

        public override string Format()
        {
            return String.Format($"{this.Signatur},{this.Autor},{this.Titel},B,{this.Seitenzahl},0");
        }
    }
    internal class CD : Medium
    {
        double Spieldauer { get; }
        internal CD(string signatur, string autor, string titel, double spieldauer)
            : base(signatur, autor, titel)
        {
            Spieldauer = spieldauer;
        }

        public override string Format()
        {
            return String.Format($"{this.Signatur},{this.Autor},{this.Titel},C,0,{this.Spieldauer}");
        }
    }
}

